/*

  This is a part of Layercut.dll source code.
  
  Copyright (C) 2001-2002 Sylvain Rouquette
  rouque_s@epita.fr
  http://www.epita.fr:8000/~rouque_s

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __UTILITY_H_
#define __UTILITY_H_

#include <string>
#include "common.h"

using namespace std;


// signed HIWORD and LOWORD
#define sHIWORD(l)   ((signed short) (((long) (l) >> 16) & 0xFFFF)) 
#define sLOWORD(l)   ((signed short) (l)) 

struct coord {
	coord():n(0),center(0),absolute(0),negative(0),primary(0) {}
	int n;
	bool center;
	bool absolute;
	bool negative;
	bool primary;
};

class Lsbox
{
public:
	HWND hwnd;
	string name;
};

void ModifyStyle(IN HWND hWnd, IN DWORD removeStyle, IN DWORD addStyle);

HWND GetLitestepDesktop();
void zOrder(HWND hWnd, Lsbox *box, bool bTopMost);

POINT convertCoords(const coord &left, const coord &top);

#endif